Fri Jun 21 13:52:17 1996 Richard Henderson <rth@tamu.edu>
[binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
53 prms send-pr gprof gdbtest tgas etc expect dejagnu sim
54 m4 autoconf ispell grep diff rcs cvs fileutils shellutils
55 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
56 recode release sed utils guile perl apache inet"
57
58
59 # these libraries are built for the target environment, and are built after
60 # the host libraries and the host tools (which may be a cross compiler)
61 #
62 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
63
64
65 # these tools are built using the target libs, and are intended to run only
66 # in the target environment
67 #
68 # note: any program that *uses* libraries that are in the "target_libs"
69 # list belongs in this list. those programs are also very likely
70 # candidates for the "native_only" list which follows
71 #
72 target_tools="target-examples target-groff"
73
74 ################################################################################
75
76 ## These two lists are of directories that are to be removed from the
77 ## ${configdirs} list for either cross-compilations or for native-
78 ## compilations. For example, it doesn't make that much sense to
79 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
80 ## a native environment.
81
82 # directories to be built in the native environment only
83 #
84 native_only="autoconf cvs emacs emacs19 fileutils find grep gzip hello
85 indent ispell m4 rcs recode sed shellutils tar textutils gash
86 uudecode wdiff gprof target-groff guile perl apache inet"
87
88 # directories to be built in a cross environment only
89 #
90 cross_only="target-libiberty target-libgloss target-newlib"
91
92 ## All tools belong in one of the four categories, and are assigned above
93 ## We assign ${configdirs} this way to remove all embedded newlines. This
94 ## is important because configure will choke if they ever get through.
95 ## ${configdirs} is directories we build using the host tools.
96 ## ${target_configdirs} is directories we build using the target tools.
97 #
98 configdirs=`echo ${host_libs} ${host_tools}`
99 target_configdirs=`echo ${target_libs} ${target_tools}`
100
101 ################################################################################
102
103 srctrigger=move-if-change
104 srcname="gnu development package"
105
106 # This gets set non-empty for some net releases of packages.
107 appdirs=""
108
109 # per-host:
110
111 # Work in distributions that contain no compiler tools, like Autoconf.
112 if [ -d ${srcdir}/config ]; then
113 case "${host}" in
114 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
115 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
116 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
117 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
118 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
119 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
120 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
121 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
122 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
123 mips*-sgi-irix[56]*) host_makefile_frag=config/mh-irix5 ;;
124 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
125 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
126 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
127 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
128 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
129 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
130 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
131 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
132 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
133 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
134 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
135 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
136 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
137 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
138 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
139 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
140 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
141 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
142 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
143 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
144 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
145 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
146 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
147 esac
148 fi
149
150 # If we aren't going to be using gcc, see if we can extract a definition
151 # of CC from the fragment.
152 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
153 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
154 found=
155 for dir in $PATH; do
156 test -z "$dir" && dir=.
157 if test -f $dir/gcc; then
158 found=yes
159 break
160 fi
161 done
162 IFS="$save_ifs"
163 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
164 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
165 if [ -n "${xx}" ] ; then
166 CC=$xx
167 fi
168 fi
169 fi
170
171 # We default to --with-shared on platforms where -fpic is meaningless.
172 # Well, we don't yet, but we will.
173 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
174 case "${target}" in
175 alpha-dec-osf*) enable_shared=yes ;;
176 alpha-*-linux*) enable_shared=yes ;;
177 mips-sgi-irix5*) enable_shared=yes ;;
178 *) enable_shared=no ;;
179 esac
180 fi
181
182 case "${enable_shared}" in
183 yes) shared=yes ;;
184 no) shared=no ;;
185 "") shared=no ;;
186 *) shared=yes ;;
187 esac
188
189 if [ x${shared} = xyes ]; then
190 waugh=
191 case "${host}" in
192 hppa*) waugh=config/mh-papic ;;
193 i[345]86-*) waugh=config/mh-x86pic ;;
194 sparc64-*) waugh=config/mh-sparcpic ;;
195 *) waugh=config/mh-${host_cpu}pic ;;
196 esac
197 if [ -f ${srcdir}/${waugh} ]; then
198 if [ -n "${host_makefile_frag}" ] ; then
199 cat ${srcdir}/${host_makefile_frag} > mh-frag
200 cat ${srcdir}/${waugh} >> mh-frag
201 host_makefile_frag=mh-frag
202 else
203 host_makefile_frag=${waugh}
204 fi
205 fi
206 fi
207
208 # per-target:
209
210 case "${target}" in
211 v810*) target_makefile_frag=config/mt-v810 ;;
212 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
213 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
214 esac
215
216 skipdirs=
217 gasdir=gas
218 use_gnu_ld=
219 use_gnu_as=
220
221 # some tools are so dependent upon X11 that if we're not building with X,
222 # it's not even worth trying to configure, much less build, that tool.
223
224 case ${with_x} in
225 yes | "") # the default value for this tree is that X11 is available
226 ;;
227 no)
228 skipdirs="${skipdirs} tk gash"
229 ;;
230 *)
231 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
232 ;;
233 esac
234
235 # Some tools are only suitable for building in a "native" situation.
236 # Those are added when we have a host==target configuration. For cross
237 # toolchains, we add some directories that should only be useful in a
238 # cross-compiler.
239
240 is_cross_compiler=
241
242 if [ x"${host}" = x"${target}" ] ; then
243 # when doing a native toolchain, don't build the targets
244 # that are in the 'cross only' list
245 skipdirs="${skipdirs} ${cross_only}"
246 is_cross_compiler=no
247 target_subdir=.
248 else
249 # similarly, don't build the targets in the 'native only'
250 # list when building a cross compiler
251 skipdirs="${skipdirs} ${native_only}"
252 is_cross_compiler=yes
253 target_subdir=${target_alias}
254 if [ ! -d ${target_subdir} ] ; then
255 if mkdir ${target_subdir} ; then true
256 else
257 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
258 exit 1
259 fi
260 fi
261 fi
262
263 copy_dirs=
264
265 # Handle --with-headers=XXX. The contents of the named directory are
266 # copied to $(tooldir)/sys-include.
267 if [ x"${with_headers}" != x ]; then
268 if [ x${is_cross_compiler} = xno ]; then
269 echo 1>&2 '***' --with-headers is only supported when cross compiling
270 exit 1
271 fi
272 case "${exec_prefixoption}" in
273 "") x=${prefix} ;;
274 *) x=${exec_prefix} ;;
275 esac
276 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
277 fi
278
279 # Handle --with-libs=XXX. Multiple directories are permitted. The
280 # contents are copied to $(tooldir)/lib.
281 if [ x"${with_libs}" != x ]; then
282 if [ x${is_cross_compiler} = xno ]; then
283 echo 1>&2 '***' --with-libs is only supported when cross compiling
284 exit 1
285 fi
286 # Copy the libraries in reverse order, so that files in the first named
287 # library override files in subsequent libraries.
288 case "${exec_prefixoption}" in
289 "") x=${prefix} ;;
290 *) x=${exec_prefix} ;;
291 esac
292 for l in ${with_libs}; do
293 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
294 done
295 fi
296
297 # If both --with-headers and --with-libs are specified, default to
298 # --without-newlib.
299 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
300 if [ x"${with_newlib}" = x ]; then
301 with_newlib=no
302 fi
303 fi
304
305 # Recognize --with-newlib/--without-newlib.
306 if [ x${with_newlib} = xno ]; then
307 skipdirs="${skipdirs} target-newlib"
308 elif [ x${with_newlib} = xyes ]; then
309 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
310 fi
311
312 # Default to using --with-stabs for certain targets.
313 if [ x${with_stabs} = x ]; then
314 case "${target}" in
315 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
316 with_stabs=yes;
317 withoptions="${withoptions} --with-stabs"
318 ;;
319 esac
320 fi
321
322 # Handle ${copy_dirs}
323 set fnord ${copy_dirs}
324 shift
325 while [ $# != 0 ]; do
326 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
327 :
328 else
329 echo Copying $1 to $2
330
331 # Use the install script to create the directory and all required
332 # parent directories.
333 if [ -d $2 ]; then
334 :
335 else
336 echo >config.temp
337 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
338 fi
339
340 # Copy the directory, assuming we have tar.
341 # FIXME: Should we use B in the second tar? Not all systems support it.
342 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
343
344 # It is the responsibility of the user to correctly adjust all
345 # symlinks. If somebody can figure out how to handle them correctly
346 # here, feel free to add the code.
347
348 echo $1 > $2/COPIED
349 fi
350 shift; shift
351 done
352
353 # Configure extra directories which are host specific
354
355 case "${host}" in
356 i[345]86-*-go32*)
357 configdirs="$configdirs dosrel" ;;
358 esac
359
360 # Remove more programs from consideration, based on the host or
361 # target this usually means that a port of the program doesn't
362 # exist yet.
363
364 noconfigdirs=""
365
366 case "${host}" in
367 i[345]86-*-vsta)
368 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
369 ;;
370 i[345]86-*-go32)
371 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
372 ;;
373 *-*-cygwin32)
374 noconfigdirs="patch diff tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
375 ;;
376 ppc*-*-pe)
377 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
378 ;;
379 esac
380
381
382 case "${target}" in
383 *-*-netware)
384 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
385 ;;
386 *-*-vxworks*)
387 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
388 ;;
389 *-*-ose)
390 noconfigdirs="$noconfigdirs target-libgloss"
391 ;;
392 alpha-dec-osf*)
393 # ld works, but does not support shared libraries. emacs doesn't
394 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
395 # gas doesn't generate exception information.
396 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
397 ;;
398 alpha*-*-*vms*)
399 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
400 ;;
401 alpha*-*-*)
402 # newlib is not 64 bit ready
403 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
404 ;;
405 # start-sanitize-arc
406 arc-*-*)
407 noconfigdirs="$noconfigdirs target-libgloss"
408 ;;
409 # end-sanitize-arc
410 arm-*-pe*)
411 noconfigdirs="$noconfigdirs target-libgloss"
412 ;;
413 arm-*-riscix*)
414 noconfigdirs="$noconfigdirs ld target-libgloss"
415 ;;
416 h8300*-*-* | \
417 h8500-*-*)
418 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
419 ;;
420 hppa*-*-*elf* | \
421 hppa*-*-lites*)
422 # Do configure ld/binutils/gas for this case.
423 ;;
424 hppa*-*-*)
425 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
426 # cc is gcc, and on any system a user should be able to link cc to
427 # whatever they want. FIXME, emacs emacs19).
428 case "${CC}" in
429 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
430 *) ;;
431 esac
432 noconfigdirs="$noconfigdirs ld shellutils"
433 ;;
434 i[345]86-*-go32)
435 # but don't build gdb
436 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
437 ;;
438 *-*-cygwin32)
439 target_configdirs="$target_configdirs target-winsup"
440 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
441 # always build newlib.
442 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
443
444 # Can't build gdb for cygwin32 if not native.
445 case "${host}" in
446 *-*-cygwin32) ;; # keep gdb
447 *) noconfigdirs="$noconfigdirs gdb"
448 esac
449 ;;
450 i[345]86-*-pe)
451 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
452 ;;
453 i[345]86-*-sco3.2v5*)
454 # The linker does not yet know about weak symbols in COFF,
455 # and is not configured to handle mixed ELF and COFF.
456 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
457 ;;
458 i[345]86-*-sco*)
459 noconfigdirs="$noconfigdirs gprof target-libgloss"
460 ;;
461 i[345]86-*-solaris2*)
462 # The linker does static linking correctly, but the Solaris C library
463 # has bugs such that some important functions won't work when statically
464 # linked. (See man pages for getpwuid, for example.)
465 noconfigdirs="$noconfigdirs ld target-libgloss"
466 ;;
467 i[345]86-*-sysv4*)
468 # The SYSV4 C compiler doesn't handle Emacs correctly
469 case "${CC}" in
470 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
471 *) ;;
472 esac
473 # but that's okay since emacs doesn't work anyway
474 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
475 ;;
476 powerpc-*-aix*)
477 # copied from rs6000-*-* entry
478 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
479 # This is needed until gcc and ld are fixed to work together.
480 use_gnu_ld=no
481 ;;
482 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
483 target_configdirs="$target_configdirs target-winsup"
484 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
485 # always build newlib.
486 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
487 ;;
488 # This is temporary until we can link against shared libraries
489 powerpcle-*-solaris*)
490 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
491 ;;
492 rs6000-*-lynxos*)
493 # The CVS server code doesn't work on the RS/6000
494 # Newlib makes problems for libg++ in crosses.
495 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
496 ;;
497 rs6000-*-aix*)
498 noconfigdirs="$noconfigdirs gprof"
499 # This is needed until gcc and ld are fixed to work together.
500 use_gnu_ld=no
501 ;;
502 rs6000-*-*)
503 noconfigdirs="$noconfigdirs gprof"
504 ;;
505 m68k-apollo-*)
506 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
507 ;;
508 mips*-*-irix5*)
509 # The GNU linker does not support shared libraries.
510 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
511 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
512 ;;
513 mips*-dec-bsd*)
514 noconfigdirs="$noconfigdirs gprof target-libgloss"
515 ;;
516 mips*-*-bsd*)
517 noconfigdirs="$noconfigdirs gprof target-libgloss"
518 ;;
519 mips*-*-*)
520 noconfigdirs="$noconfigdirs gprof"
521 ;;
522 romp-*-*)
523 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
524 ;;
525 sh-*-*)
526 case "${host}" in
527 i[345]86-*-vsta) ;; # don't add gprof back in
528 i[345]86-*-go32) ;; # don't add gprof back in
529 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
530 esac
531 noconfigdirs="$noconfigdirs target-libgloss"
532 ;;
533 sparc-*-sunos4*)
534 if [ x${is_cross_compiler} != xno ] ; then
535 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
536 else
537 use_gnu_ld=no
538 fi
539 ;;
540 v810-*-*)
541 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
542 ;;
543 vax-*-vms)
544 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
545 ;;
546 vax-*-*)
547 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
548 ;;
549 *-*-lynxos*)
550 # Newlib makes problems for libg++ in crosses.
551 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
552 ;;
553 *-*-macos* | \
554 *-*-mpw*)
555 # Macs want a resource compiler.
556 configdirs="$configdirs grez"
557 ;;
558 esac
559
560 # targets that need a second pass
561 case "${target}" in
562 *-gm-magic*)
563 noconfigdirs="$noconfigdirs target-libgloss"
564 ;;
565 esac
566
567 # If we aren't building newlib, then don't build libgloss, since libgloss
568 # depends upon some newlib header files.
569 case "${noconfigdirs}" in
570 *target-libgloss*) ;;
571 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
572 esac
573
574 # If we are building a Canadian Cross, discard tools that can not be built
575 # using a cross compiler. FIXME: These tools should be fixed.
576 if [ "${build}" != "${host}" ]; then
577 noconfigdirs="$noconfigdirs expect dejagnu texinfo diff"
578 fi
579
580 # Make sure we don't let GNU ld be added if we didn't want it.
581 if [ x$with_gnu_ld = xno ]; then
582 use_gnu_ld=no
583 noconfigdirs="$noconfigdirs ld"
584 fi
585
586 # Make sure we don't let GNU as be added if we didn't want it.
587 if [ x$with_gnu_as = xno ]; then
588 use_gnu_as=no
589 noconfigdirs="$noconfigdirs gas"
590 fi
591
592 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
593 # $target_configdirs.
594 # If we have the source for $noconfigdirs entries, add them to $notsupp.
595
596 notsupp=""
597 for dir in . $skipdirs $noconfigdirs ; do
598 dirname=`echo $dir | sed -e s/target-//g`
599 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
600 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
601 if [ -r $srcdir/$dirname/configure ] \
602 || [ -r $srcdir/$dirname/configure.in ]; then
603 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
604 true
605 else
606 notsupp="$notsupp $dir"
607 fi
608 fi
609 fi
610 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
611 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
612 if [ -r $srcdir/$dirname/configure ] \
613 || [ -r $srcdir/$dirname/configure.in ]; then
614 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
615 true
616 else
617 notsupp="$notsupp $dir"
618 fi
619 fi
620 fi
621 done
622
623 # Sometimes the tools are distributed with libiberty but with no other
624 # libraries. In that case, we don't want to build target-libiberty.
625 if [ -n "${target_configdirs}" ]; then
626 others=
627 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
628 if [ "$i" != "libiberty" ]; then
629 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
630 others=yes;
631 break;
632 fi
633 fi
634 done
635 if [ -z "${others}" ]; then
636 target_configdirs=
637 fi
638 fi
639
640 # Deconfigure all subdirectories, in case we are changing the
641 # configuration from one where a subdirectory is supported to one where it
642 # is not.
643 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
644 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
645 rm -f $i/Makefile
646 done
647 fi
648 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
649 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
650 rm -f ${target_subdir}/$i/Makefile
651 done
652 fi
653
654 # Produce a warning message for the subdirs we can't configure.
655 # This isn't especially interesting in the Cygnus tree, but in the individual
656 # FSF releases, it's important to let people know when their machine isn't
657 # supported by the one or two programs in a package.
658
659 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
660 # If $appdirs is non-empty, at least one of those directories must still
661 # be configured, or we error out. (E.g., if the gas release supports a
662 # specified target in some subdirs but not the gas subdir, we shouldn't
663 # pretend that all is well.)
664 if [ -n "$appdirs" ]; then
665 for dir in $appdirs ; do
666 if [ -r $dir/Makefile.in ]; then
667 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
668 appdirs=""
669 break
670 fi
671 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
672 appdirs=""
673 break
674 fi
675 fi
676 done
677 if [ -n "$appdirs" ]; then
678 echo "*** This configuration is not supported by this package." 1>&2
679 exit 1
680 fi
681 fi
682 # Okay, some application will build, or we don't care to check. Still
683 # notify of subdirs not getting built.
684 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
685 echo " ${notsupp}" 1>&2
686 echo " (Any other directories should still work fine.)" 1>&2
687 fi
688
689 # Set with_gnu_as and with_gnu_ld as appropriate.
690 #
691 # This is done by determining whether or not the appropriate directory
692 # is available, and by checking whether or not specific configurations
693 # have requested that this magic not happen.
694 #
695 # The command line options always override the explicit settings in
696 # configure.in, and the settings in configure.in override this magic.
697 #
698 # If the default for a toolchain is to use GNU as and ld, and you don't
699 # want to do that, then you should use the --without-gnu-as and
700 # --without-gnu-ld options for the configure script.
701
702 if [ x${use_gnu_as} = x ] ; then
703 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
704 with_gnu_as=yes
705 withoptions="$withoptions --with-gnu-as"
706 fi
707 fi
708
709 if [ x${use_gnu_ld} = x ] ; then
710 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
711 with_gnu_ld=yes
712 withoptions="$withoptions --with-gnu-ld"
713 fi
714 fi
715
716 if [ x${shared} = xyes ]; then
717 case "${target}" in
718 hppa*) target_makefile_frag=config/mt-papic ;;
719 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
720 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
721 esac
722 fi
723
724 # post-target:
725
726 # Make sure that the compiler is able to generate an executable. If it
727 # can't, we are probably in trouble. We don't care whether we can run the
728 # executable--we might be using a cross compiler--we only care whether it
729 # can be created. At this point the main configure script has set CC.
730 echo "int main () { return 0; }" > conftest.c
731 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
732 if [ $? = 0 ] && [ -s conftest ]; then
733 :
734 else
735 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
736 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
737 rm -f conftest*
738 exit 1
739 fi
740 rm -f conftest*
741
742 # The Solaris /usr/ucb/cc compiler does not appear to work.
743 case "${host}" in
744 sparc-sun-solaris2*)
745 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
746 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
747 could_use=
748 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
749 if [ -d /opt/cygnus/bin ] ; then
750 if [ "$could_use" = "" ] ; then
751 could_use="/opt/cygnus/bin"
752 else
753 could_use="$could_use or /opt/cygnus/bin"
754 fi
755 fi
756 if [ "$could_use" = "" ] ; then
757 echo "Warning: compilation may fail because you're using"
758 echo "/usr/ucb/cc. You should change your PATH or CC "
759 echo "variable and rerun configure."
760 else
761 echo "Warning: compilation may fail because you're using"
762 echo "/usr/ucb/cc, when you should use the C compiler from"
763 echo "$could_use. You should change your"
764 echo "PATH or CC variable and rerun configure."
765 fi
766 fi
767 ;;
768 esac
769
770 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
771 # binutils tools will find libbfd.so.
772 if [ "${shared}" = "yes" ]; then
773 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
774 Makefile > Makefile.tem
775 rm -f Makefile
776 mv -f Makefile.tem Makefile
777
778 case "${host}" in
779 *-*-hpux*)
780 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
781 Makefile > Makefile.tem
782 rm -f Makefile
783 mv -f Makefile.tem Makefile
784 ;;
785 esac
786 fi
787
788 # Record target_configdirs and the configure arguments in Makefile.
789 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
790 targargs=`echo "${arguments}" | \
791 sed -e 's/--norecursion//' \
792 -e 's/--cache[a-z-]*=[^ ]*//' \
793 -e 's/--ho[a-z-]*=[^ ]*//' \
794 -e 's/--ta[a-z-]*=[^ ]*//'`
795
796 # Passing a --with-cross-host argument lets the target libraries know
797 # whether they are being built with a cross-compiler or being built
798 # native. However, it would be better to use other mechanisms to make the
799 # sorts of decisions they want to make on this basis. Please consider
800 # this option to be deprecated. FIXME.
801 if [ x${is_cross_compiler} = xyes ]; then
802 targargs="--with-cross-host=${host_alias} ${targargs}"
803 fi
804
805 targargs="--host=${target_alias} ${targargs}"
806 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
807 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
808 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
809 Makefile > Makefile.tem
810 rm -f Makefile
811 mv -f Makefile.tem Makefile
812
813 #
814 # Local Variables:
815 # fill-column: 131
816 # End:
817 #